<?php

namespace SM\Controller;

use SM\Util\Utilities;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00005000TabParametrizacoesEmailService;
use SM\Traits\TResponse;

class Sm00005000TabParametrizacoesEmailController
{
    use TResponse;

    protected $parametrizacaoEmailService;

    public function __construct(Sm00005000TabParametrizacoesEmailService $parametrizacaoEmailService)
    {
        $this->parametrizacaoEmailService = $parametrizacaoEmailService;
    }

    public function getParametrosEmailFilial()
    {
        try {
            $data = $this->parametrizacaoEmailService->getParametrosEmailFilial();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveParameterEmail(Request $request)
    {
        try {
            $data = $this->parametrizacaoEmailService->saveParameterEmail($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteParametrosEmail(Request $request)
    {
        try {
            $data = $this->parametrizacaoEmailService->deleteParametrosEmail($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
