<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class LogCallbackCertisignFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function logCallbackCertisign()
    {

        $sql = "SELECT LOGAD.NRLOGASSINATDIGITAL, LOGAD.NRSEQORCAMENTO, LOGAD.NRSEQCONTRATO, LOGAD.IDDOCUMCERTSIGN, LOGAD.NRCPFSIGNATARIO, LOGAD.NRSEQORCADOC,
                LOGAD.NRSEQCONTDOC, LOGAD.DSERRO, LOGAD.NRORG, TO_CHAR(LOGAD.DTINCLUSAO, 'DD/MM/YYYY HH24:MI') DTINCLUSAO, PROP.NRORCAMENTO, CONT.NRCONTRATOFCT,
                NVL(PCP.NRPARCNEGOCIO, PCC.NRPARCNEGOCIO) NRPARCNEGOCIO,
                NVL(PCP.NMPRINCIPALPARC, PCC.NMPRINCIPALPARC) AS NMPRINCIPALPARC,
                NVL(MDP.NRSEQMODDOCFCT, MDC.NRSEQMODDOCFCT) AS NRDOCUMENTO,
                NVL(MDP.DSMODELODOCORCA, MDC.DSMODELODOCORCA) AS NMDOCUMENTO
                            FROM FCT_LOGASSINATDIGITAL LOGAD
                            LEFT JOIN FCT_ORCAMENTO PROP
                            ON PROP.NRSEQORCAMENTO = LOGAD.NRSEQORCAMENTO
                            LEFT JOIN PARCNEGOCIO PCP
                            ON PCP.NRPARCNEGOCIO = PROP.NRPARCNEGOCIO
                            LEFT JOIN FCT_CONTRATO CONT
                            ON CONT.NRSEQCONTRATO = LOGAD.NRSEQCONTRATO
                            LEFT JOIN PARCNEGOCIO PCC
                            ON PCC.NRPARCNEGOCIO = CONT.NRPARCNEGOCIO
                            LEFT JOIN FCT_ORCAMENTODOC ORC
                            ON ORC.NRSEQORCADOC = LOGAD.NRSEQORCADOC
                            LEFT JOIN FCT_MODELODOC MDP
                            ON MDP.NRSEQMODDOCFCT = ORC.NRSEQMODDOCFCT
                            LEFT JOIN FCT_CONTRATODOC CDOC
                            ON CDOC.NRSEQCONTDOC = LOGAD.NRSEQCONTDOC
                            LEFT JOIN FCT_MODELODOC MDC
                            ON MDC.NRSEQMODDOCFCT = CDOC.NRSEQMODDOCFCT";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getProposal()
    {
        $sql = "SELECT NRSEQORCAMENTO, NRORCAMENTO
                    FROM FCT_ORCAMENTO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getContractsLog()
    {
        $sql = "SELECT NRSEQCONTRATO, NRCONTRATOFCT
                    FROM FCT_CONTRATO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
