<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00054002ReducaoQuantidadeMedidaPerfilAcessoFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getReducaoQuantidadeMedidaPerfilAcesso()
    {

        $sql = "SELECT AL.NRALTERAQTMEDPERF,
                       AL.NRPERFILACESSO,
                       AL.IDATIVO,
                       AL.DTINCLUSAO,
                       AL.NRORGINCLUSAO,
                       AL.NRORG,
                       AL.CDOPERINCLUSAO,
                       AL.CDOPERULTATU,
                       AL.NRORGULTATU,
                       AL.DTULTATU,
                       PR.NMPERFILACESSO
                    FROM FCT_ALTERAQTMEDPERFACESS AL
                    JOIN PERFILACESSO PR ON AL.NRPERFILACESSO = PR.NRPERFILACESSO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function validaReducaoPerfilAcesso(array $params)
    {

        $sql = "SELECT COUNT (*) AS QTD
                FROM FCT_ALTERAQTMEDPERFACESS
                WHERE NRPERFILACESSO = :NRPERFILACESSO
                AND NRALTERAQTMEDPERF <> NVL(:NRALTERAQTMEDPERF,-1)";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function inserirReducaoQuantidadeMedidaPerfilAcesso($parametros)
    {

        $sql = "INSERT INTO  FCT_ALTERAQTMEDPERFACESS (
                NRALTERAQTMEDPERF, NRPERFILACESSO,NRORG, IDATIVO,
                DTINCLUSAO, NRORGINCLUSAO, 
                CDOPERINCLUSAO)
                VALUES (
                 :NRALTERAQTMEDPERF, :NRPERFILACESSO, :NRORG,  :IDATIVO,
                 SYSDATE, :NRORGINCLUSAO,:CDOPERINCLUSAO
                
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarReducaoQuantidadeMedidaPerfilAcesso($parametros)
    {
        $sql = "UPDATE FCT_ALTERAQTMEDPERFACESS
                SET NRPERFILACESSO = :NRPERFILACESSO,
                    NRORG = :NRORG,
                    IDATIVO = :IDATIVO,
                    NRORGINCLUSAO = :NRORGINCLUSAO,
                    CDOPERINCLUSAO = :CDOPERINCLUSAO
                WHERE NRALTERAQTMEDPERF = :NRALTERAQTMEDPERF";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function deletarReducaoQuantidadeMedidaPerfilAcesso($parametros)
    {
        $sql = "DELETE FROM FCT_ALTERAQTMEDPERFACESS WHERE NRALTERAQTMEDPERF = :NRALTERAQTMEDPERF ";
        $this->connection->executeStatement($sql, $parametros);
    }
}
