-- =============================================================================
-- Sistema   : Comercial Comissaria
-- Data      : 31/01/2003
-- Criao   : Leonardo Monteiro
-- Obsjetivo : Gerar o relatrio de Faturamento por Vo/Perodo
-- =============================================================================
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\1300_COCSTP_CalculaMarkUp.sql
-- =============================================================================
-- dbms_output.put_line(V_DSFORMITFIMU);
-- SET SERVEROUTPUT ON
-- VAR P_RESULTADO VARCHAR2(80);
-- EXECUTE CALCULAMARKUP('001','001','006','',:P_RESULTADO)
-- =============================================================================
CREATE OR REPLACE PROCEDURE CALCULAMARKUP(
P_CDMARKUP     IN  ITFICHAFPRMU.CDMARKUP    %TYPE,
P_CDFICHAFPR   IN  ITFICHAFPRMU.CDFICHAFPR  %TYPE,
P_CDITFICHAFPR IN  ITFICHAFPRMU.CDITFICHAFPR%TYPE,
P_DSFORMITFIMU IN  ITFICHAFPRMU.DSFORMITFIMU%TYPE, /*No  necessrio informar.*/
P_RESULTADO    OUT VARCHAR2
)
AS
V_CDITFICHAFPR ITFICHAFPRMU.CDITFICHAFPR%TYPE;
V_DSFORMITFIMU ITFICHAFPRMU.DSFORMITFIMU%TYPE;
V_SGITFICHAFPR ITFICHAFPR  .SGITFICHAFPR%TYPE;

V_SELECT_TEXT  VARCHAR2(1000);
C_SELECT       INTEGER;
V_RESULT       INTEGER;
V_VRFORMITFIMU NUMBER;
BEGIN

	IF TRIM(P_DSFORMITFIMU) IS NULL THEN
      SELECT DECODE(MAX(P_CDITFICHAFPR),NULL,MAX(FM.DSFORMFICHMU),MAX(IM.DSFORMITFIMU))
      --NVL(MAX(IM.DSFORMITFIMU),MAX(FM.DSFORMFICHMU))
      INTO V_DSFORMITFIMU
      FROM ITFICHAFPRMU IM, FICHAFPRMU FM
      WHERE (FM.CDMARKUP        = P_CDMARKUP    ) AND
            (FM.CDFICHAFPR      = P_CDFICHAFPR  ) AND
            (IM.CDMARKUP    (+) = FM.CDMARKUP   ) AND
            (IM.CDFICHAFPR  (+) = FM.CDFICHAFPR ) AND
            (IM.CDITFICHAFPR(+) = P_CDITFICHAFPR);
   ELSE
   	V_DSFORMITFIMU := P_DSFORMITFIMU;
   END IF;

	/*IF TRIM(P_DSFORMITFIMU) IS NULL THEN
      SELECT MAX(DSFORMITFIMU)
      INTO V_DSFORMITFIMU
      FROM ITFICHAFPRMU
      WHERE (CDMARKUP     = P_CDMARKUP    ) AND
            (CDFICHAFPR   = P_CDFICHAFPR  ) AND
            (CDITFICHAFPR = P_CDITFICHAFPR);
   ELSE
   	V_DSFORMITFIMU := P_DSFORMITFIMU;
   END IF;*/

   FOR C_ITEM IN(SELECT IM.CDITFICHAFPR,IP.SGITFICHAFPR,IM.DSFORMITFIMU
                 FROM ITFICHAFPRMU IM, ITFICHAFPR IP, PARGERALCOC PC
                 WHERE (IM.CDMARKUP      = P_CDMARKUP      ) AND
                       (IM.CDFICHAFPR    = P_CDFICHAFPR    ) AND
                       (IM.CDFICHAFPR   <> PC.CDFICHAFPR(+)) AND
                       (IM.IDITFICHAFPR <> 'S'             ) AND
                       (IP.CDFICHAFPR    = P_CDFICHAFPR    ) AND
                       (IP.CDITFICHAFPR  = IM.CDITFICHAFPR ) AND
                       (INSTR(V_DSFORMITFIMU,IP.SGITFICHAFPR)>0) AND
                       (TRIM(IM.DSFORMITFIMU) IS NOT NULL)) LOOP

      V_DSFORMITFIMU := REPLACE(V_DSFORMITFIMU,C_ITEM.SGITFICHAFPR,C_ITEM.DSFORMITFIMU);

      SELECT MAX(SGITFICHAFPR)
      INTO V_SGITFICHAFPR
      FROM ITFICHAFPR
      WHERE (CDFICHAFPR   = P_CDFICHAFPR  ) AND
            (CDITFICHAFPR = P_CDITFICHAFPR);

      IF (V_DSFORMITFIMU IS NOT NULL) OR (INSTR(V_DSFORMITFIMU,V_SGITFICHAFPR) = 0) THEN
         CALCULAMARKUP(P_CDMARKUP,P_CDFICHAFPR,C_ITEM.CDITFICHAFPR,V_DSFORMITFIMU,V_DSFORMITFIMU);
      END IF;
   END LOOP;

   V_DSFORMITFIMU := REPLACE(V_DSFORMITFIMU,' ','');

   IF SUBSTR(V_DSFORMITFIMU,1,2) = '<<' THEN
   	P_RESULTADO := V_DSFORMITFIMU;
   ELSE
      V_SELECT_TEXT := '';
      V_SELECT_TEXT := V_SELECT_TEXT||' SELECT NVL('||REPLACE(V_DSFORMITFIMU,',','.')||',0) AS CALC';
      V_SELECT_TEXT := V_SELECT_TEXT||' FROM PARAMGERAL';

      C_SELECT := DBMS_SQL.OPEN_CURSOR;
      DBMS_SQL.PARSE(C_SELECT,V_SELECT_TEXT,DBMS_SQL.V7);
      DBMS_SQL.DEFINE_COLUMN(C_SELECT,1,V_VRFORMITFIMU);

      V_RESULT := DBMS_SQL.EXECUTE(C_SELECT);
      IF DBMS_SQL.FETCH_ROWS(C_SELECT)>0 THEN
         DBMS_SQL.COLUMN_VALUE(C_SELECT,1,V_VRFORMITFIMU);
      END IF;
      DBMS_SQL.CLOSE_CURSOR(C_SELECT);

      P_RESULTADO := TO_CHAR(V_VRFORMITFIMU);
   END IF;
EXCEPTION
	WHEN OTHERS THEN
   	IF DBMS_SQL.IS_OPEN(C_SELECT) THEN
   		DBMS_SQL.CLOSE_CURSOR(C_SELECT);
   		P_RESULTADO := '<<'||V_DSFORMITFIMU||'>>';
      ELSE
      	RAISE;
      END IF;
END;
/

